## mingw-w64-cli11-2.6.2-1.src.tar.zst

=== tests/module_test/CMakeLists.txt ===
# Copyright (c) 2017-2026, University of Cincinnati, developed by Henry Schreiner
# under NSF AWARD 1414736 and by the respective contributors.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.28...4.2)
set(CMAKE_CXX_EXTENSIONS OFF)

project(CLI11-module-test)

include(CTest)

if(CLI11_DIR)
  set(CMAKE_PREFIX_PATH ${CLI11_DIR})
endif()

set(CMAKE_CXX_STANDARD 23)

# Test the CLI11 CMake package config
find_package(CLI11 2.5 REQUIRED)

# Test inclusion of CLI11 in modules
add_executable(module-include-test module_include_test.cpp)

target_sources(module-include-test PUBLIC FILE_SET cmodule TYPE CXX_MODULES FILES cmodule.ixx)

target_link_libraries(module-include-test CLI11::CLI11)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(module-include-test PUBLIC -fmodules-ts)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  if(CLI11_FORCE_LIBCXX)
    set_property(
      TARGET module-include-test
      APPEND_STRING
      PROPERTY LINK_FLAGS -stdlib=libc++)
    target_link_libraries(module-include-test c++abi)
    #target_link_libraries(module-include-test c++)
  endif()
endif()

add_test(NAME module-include-test1 COMMAND module-include-test one)
set_property(TEST module-include-test1 PROPERTY PASS_REGULAR_EXPRESSION "OK: export module")

# Test the CLI11 Module target if available
if(CLI11_MODULES)
  # Test the target
  add_executable(module-test module_test.cpp)

  target_link_libraries(module-test CLI11::CLI11_Module)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(module-test PUBLIC -fmodules-ts)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    if(CLI11_FORCE_LIBCXX)
      set_property(
        TARGET module-test
        APPEND_STRING
        PROPERTY LINK_FLAGS -stdlib=libc++)
      target_link_libraries(module-test c++abi)
      # target_link_libraries(module-test c++)
    endif()
  endif()

  add_test(NAME module-test1 COMMAND module-test one)
  set_property(TEST module-test1 PROPERTY PASS_REGULAR_EXPRESSION
                                          "OK: import cli11 module\nvalue = one")
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmailcom>

_realname=CLI11
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname,,}")
pkgver=2.6.2
pkgrel=1
pkgdesc="Command line parser for C++11 (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/CLIUtils/CLI11"
msys2_repository_url='https://github.com/CLIUtils/CLI11'
msys2_references=(
  'archlinux: cli11'
  'gentoo: dev-cpp/cli11'
)
license=(spdx:BSD-3-Clause)
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=(${url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz)
noextract=("${_realname}-${pkgver}.tar.gz")
sha256sums=('c6ea6b2e5608b3ea8617999bd5f47420c71b2ebdb8dc4767c1034d1da5785711')

prepare() {
  rm -rf ${_realname}-${pkgver}
  tar -xzf ${_realname}-${pkgver}.tar.gz || true
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    ${extra_config[@]} \
    -DCLI11_BUILD_TESTS=OFF \
    -DCLI11_BUILD_EXAMPLES=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE -t "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname,,}/
}
